symfony/src/Entity/Booking.php
<?php
namespace App\Entity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
/**
 * @ORM\Entity(repositoryClass="App\Repository\BookingRepository")
 * @ORM\HasLifecycleCallbacks()
 */
class Booking
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;
    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\User", inversedBy="bookings")
     * @ORM\JoinColumn(nullable=false)
     */
    private $booker;
    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\Ad", inversedBy="bookings")
     * @ORM\JoinColumn(nullable=false)
     */
    private $ad;
    /**
     * @ORM\Column(type="datetime")
     * @Assert\Date(message="Attention, la date d'arrivée doit être au bon format !")
     * @Assert\GreaterThan("today", message="La date d'arrivée doit être ultérieure à la date d'aujourd'hui !", groups={"front"})
     */
    private $startDate;
    /**
     * @ORM\Column(type="datetime")
     * @Assert\Date(message="Attention, la date de départ doit être au bon format !")
     * @Assert\GreaterThan(propertyPath="startDate", message="La date de départ doit être plus éloignée que la date d'arrivée !")
     */
    private $endDate;
    /**
     * @ORM\Column(type="datetime")
     */
    private $createdAt;
    /**
     * @ORM\Column(type="float")
     */
    private $amount;
    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $comment;
    /**
     * Callback appelé à chaque fois qu'on créé une réservation
     *
     * @ORM\PrePersist
     * @ORM\PreUpdate
     * 
     * @return void
     */
    public function prePersist() {
        if(empty($this->createdAt)) {
            $this->createdAt = new \DateTime();
        }
        if(empty($this->amount)) {
            // prix de l'annonce * nombre de jour
            $this->amount = $this->ad->getPrice() * $this->getDuration();
        }
    }
    /**
     * Permet de savoir si les dates réservées sont disponibles ou non
     *
     * @return boolean 
     */
    public function isBookableDates() {
        // 1) Il faut connaitre les dates qui sont impossibles pour l'annonce
        $notAvailableDays = $this->ad->getNotAvailableDays();
        // 2) Il faut comparer les dates choisies avec les dates impossibles
        $bookingDays      = $this->getDays();
        $formatDay = function($day){
            return $day->format('Y-m-d');
        };
        // Tableau des chaines de caractères de mes journées
        $days           = array_map($formatDay, $bookingDays);
        $notAvailable   = array_map($formatDay, $notAvailableDays);
        foreach($days as $day) {
            if(array_search($day, $notAvailable) !== false) return false;
        }
        return true;
    }
    /**
     * Permet de récupérer un tableau des journées qui correspondent à ma réservation
     *
     * @return array Un tableau d'objets DateTime représentant les jours de la réservation
     */
    public function getDays() {
        $resultat = range(
            $this->startDate->getTimestamp(),
            $this->endDate->getTimestamp(),
            24 * 60 * 60
        );
        $days =  array_map(function($dayTimestamp) {
            return new \DateTime(date('Y-m-d', $dayTimestamp));
        }, $resultat);
        return $days;
    }
    public function getDuration() {
        $diff = $this->endDate->diff($this->startDate);
        return $diff->days;
    }
    public function getId()
    {
        return $this->id;
    }
    public function getBooker(): ?User
    {
        return $this->booker;
    }
    public function setBooker(?User $booker): self
    {
        $this->booker = $booker;
        return $this;
    }
    public function getAd(): ?Ad
    {
        return $this->ad;
    }
    public function setAd(?Ad $ad): self
    {
        $this->ad = $ad;
        return $this;
    }
    public function getStartDate(): ?\DateTimeInterface
    {
        return $this->startDate;
    }
    public function setStartDate(\DateTimeInterface $startDate): self
    {
        $this->startDate = $startDate;
        return $this;
    }
    public function getEndDate(): ?\DateTimeInterface
    {
        return $this->endDate;
    }
    public function setEndDate(\DateTimeInterface $endDate): self
    {
        $this->endDate = $endDate;
        return $this;
    }
    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->createdAt;
    }
    public function setCreatedAt(\DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;
        return $this;
    }
    public function getAmount(): ?float
    {
        return $this->amount;
    }
    public function setAmount(float $amount): self
    {
        $this->amount = $amount;
        return $this;
    }
    public function getComment(): ?string
    {
        return $this->comment;
    }
    public function setComment(?string $comment): self
    {
        $this->comment = $comment;
        return $this;
    }
}

symfony/src/Entity/User.php
<?php

namespace App\Entity;

use Cocur\Slugify\Slugify;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;

/**
 * @ORM\Entity(repositoryClass="App\Repository\UserRepository")
 * @ORM\HasLifecycleCallbacks()
 * @UniqueEntity(
 *  fields={"email"},
 *  message="Cette email est deja utilisée"
 * )
 */
class User implements UserInterface
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank()
     */
    private $firstName;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank()
     */
    private $lastName;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Email(message="Veuillez renseigner un email valide !")
     */
    private $email;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @Assert\Url(message="Veuillez renseigner une URL valide")
     */
    private $picture;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $hash;

    /**
     * @Assert\EqualTo(propertyPath="hash", message="le mot de passe n'est pas confirmer !")
     */
    public $passwordConfirm;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Length(min=10, minMessage="Votre présentation doit faire au moins 10 caracteres")
     */
    private $presentation;

    /**
     * @ORM\Column(type="text")
     * @Assert\Length(min=100, minMessage="Votre présentation doit faire au moins 100 caracteres")
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $slug;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Ad", mappedBy="author")
     */
    private $ads;

    /**
     * @ORM\ManyToMany(targetEntity="App\Entity\Role", mappedBy="users")
     */
    private $userRoles;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Booking", mappedBy="booker")
     */
    private $bookings;

    /**
     * @ORM\OneToMany(targetEntity="App\Entity\Comment", mappedBy="author", orphanRemoval=true)
     */
    private $comments;

    public function getFullName(){
        $this->firstName = ucfirst($this->firstName);
        $this->lastName = ucfirst($this->lastName);
        return "{$this->firstName} {$this->lastName}";
    }

    /**
     * Permet d'initialiser le slug
     * 
     * @ORM\PrePersist
     * @ORM\PreUpdate
     *
     * @return void
     */
    public function initializeSlug(){
        if(empty($this->slug)){
            $slugify = new Slugify();
            $this->slug = $slugify->Slugify($this->firstName . ' ' . $this->lastName);
        }
    }

    public function __construct()
    {
        $this->ads = new ArrayCollection();
        $this->userRoles = new ArrayCollection();
        $this->bookings = new ArrayCollection();
        $this->comments = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFirstName(): ?string
    {
        return $this->firstName;
    }

    public function setFirstName(string $firstName): self
    {
        $this->firstName = $firstName;

        return $this;
    }

    public function getLastName(): ?string
    {
        return $this->lastName;
    }

    public function setLastName(string $lastName): self
    {
        $this->lastName = $lastName;

        return $this;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    public function getPicture(): ?string
    {
        return $this->picture;
    }

    public function setPicture(?string $picture): self
    {
        $this->picture = $picture;

        return $this;
    }

    public function getHash(): ?string
    {
        return $this->hash;
    }

    public function setHash(string $hash): self
    {
        $this->hash = $hash;

        return $this;
    }

    public function getPresentation(): ?string
    {
        return $this->presentation;
    }

    public function setPresentation(string $presentation): self
    {
        $this->presentation = $presentation;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    /**
     * @return Collection|Ad[]
     */
    public function getAds(): Collection
    {
        return $this->ads;
    }

    public function addAd(Ad $ad): self
    {
        if (!$this->ads->contains($ad)) {
            $this->ads[] = $ad;
            $ad->setAuthor($this);
        }

        return $this;
    }

    public function removeAd(Ad $ad): self
    {
        if ($this->ads->contains($ad)) {
            $this->ads->removeElement($ad);
            // set the owning side to null (unless already changed)
            if ($ad->getAuthor() === $this) {
                $ad->setAuthor(null);
            }
        }

        return $this;
    }

    public function getRoles()
    {
       
        $roles = $this->userRoles->map(function($role){
            return $role->getTitle();
        })->toArray();

        $roles[] = 'ROLE_USER';

        return $roles;
    }

    public function getPassword()
    {
        return $this->hash;
    }
    public function getSalt() {}

    public function getUsername()
    {
        return $this->email;
    }
    public function eraseCredentials() {}

    /**
     * @return Collection|Role[]
     */
    public function getUserRoles(): Collection
    {
        return $this->userRoles;
    }

    public function addUserRole(Role $userRole): self
    {
        if (!$this->userRoles->contains($userRole)) {
            $this->userRoles[] = $userRole;
            $userRole->addUser($this);
        }

        return $this;
    }

    public function removeUserRole(Role $userRole): self
    {
        if ($this->userRoles->contains($userRole)) {
            $this->userRoles->removeElement($userRole);
            $userRole->removeUser($this);
        }

        return $this;
    }

    /**
     * @return Collection|Booking[]
     */
    public function getBookings(): Collection
    {
        return $this->bookings;
    }

    public function addBooking(Booking $booking): self
    {
        if (!$this->bookings->contains($booking)) {
            $this->bookings[] = $booking;
            $booking->setBooker($this);
        }

        return $this;
    }

    public function removeBooking(Booking $booking): self
    {
        if ($this->bookings->contains($booking)) {
            $this->bookings->removeElement($booking);
            // set the owning side to null (unless already changed)
            if ($booking->getBooker() === $this) {
                $booking->setBooker(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }

    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setAuthor($this);
        }

        return $this;
    }

    public function removeComment(Comment $comment): self
    {
        if ($this->comments->contains($comment)) {
            $this->comments->removeElement($comment);
            // set the owning side to null (unless already changed)
            if ($comment->getAuthor() === $this) {
                $comment->setAuthor(null);
            }
        }

        return $this;
    }
}

symfony/src/Form/BookingType.php
<?php
namespace App\Form;
use App\Entity\Booking;
use App\Form\ApplicationType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use App\Form\DataTransformer\FrenchToDateTimeTransformer;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
class BookingType extends ApplicationType
{
    private $transformer;
    public function __construct(FrenchToDateTimeTransformer $transformer){
        $this->transformer = $transformer;
    }
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('startDate', TextType::class, $this->getConfiguration("Date d'arrivée", "La date à laquelle vous comptez arriver"))
            ->add('endDate', TextType::class, $this->getConfiguration("Date de départ", "La date à laquelle vous quittez les lieux"))
            ->add('comment', TextareaType::class, $this->getConfiguration(false, "Si vous avez un commentaire, n'hésitez pas à en faire part !", ["required" => false]))
        ;
        $builder->get('startDate')->addModelTransformer($this->transformer);
        $builder->get('endDate')->addModelTransformer($this->transformer);
    }
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Booking::class,
            'validation_groups' => [
                'Default',
                'front'
            ]
        ]);
    }
}

symfony/src/Controller/BookingController.php
<?php
namespace App\Controller;
use App\Entity\Ad;
use App\Entity\Booking;
use App\Entity\Comment;
use App\Form\BookingType;
use App\Form\CommentType;
use Symfony\Component\HttpFoundation\Request;
use Doctrine\Common\Persistence\ObjectManager;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
class BookingController extends Controller
{
    /**
     * @Route("/ads/{slug}/book", name="booking_create")
     * @IsGranted("ROLE_USER")
     */
    public function book(Ad $ad, Request $request, ObjectManager $manager)
    {
        $booking = new Booking();
        $form = $this->createForm(BookingType::class, $booking);
        
        $form->handleRequest($request);
        if($form->isSubmitted() && $form->isValid()) {
            $user = $this->getUser();
            $booking->setBooker($user)
                    ->setAd($ad);
            // Si les dates ne sont pas disponibles, message d'erreur
            if(!$booking->isBookableDates()) {
                $this->addFlash(
                    'warning',
                    "Les dates que vous avez choisi ne peuvent être réservées : elles sont déjà prises."
                );
            } else {
                // Sinon enregistrement et redirection
                $manager->persist($booking);
                $manager->flush();
    
                return $this->redirectToRoute('booking_show', ['id' => $booking->getId(), 'withAlert' => true]);
            }
        }
        return $this->render('booking/book.html.twig', [
            'ad' => $ad,
            'form' => $form->createView()
        ]);
    }
    /**
     * Permet d'afficher la page d'une réservation
     *
     * @Route("/booking/{id}", name="booking_show")
     * 
     * @param Booking $booking
     * @param Request $request
     * @param ObjectManager $manager
     * @return Response
     */
    public function show(Booking $booking, Request $request, ObjectManager $manager) {
        $comment = new Comment();
        $form = $this->createForm(CommentType::class, $comment);
        $form->handleRequest($request);
        if($form->isSubmitted() && $form->isValid()) {
            $comment->setAd($booking->getAd())
                    ->setAuthor($this->getUser());
            $manager->persist($comment);
            $manager->flush();
            $this->addFlash(
                'success',
                "Votre commentaire a bien été pris en compte !"
            );
        }
        return $this->render('booking/show.html.twig', [
            'booking' => $booking,
            'form'    => $form->createView()
        ]);
    }
    
}

symfony/templates/booking/book.html.twig
{% extends 'base.html.twig' %}

{% block title %}Réserver l'annonce : {{ad.title}} !{% endblock %}

{% block stylesheets %}
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/css/bootstrap-datepicker.min.css" />
{% endblock %}

{% block body %}
    <div class="container">
        <h1>Réservez pour l'annonce : <em>{{ ad.title }}</em></h1>

        <p>Vous êtes sur le point de réserver le bien de <strong>{{ ad.author.fullName }}</strong>, dites nous tout, on s'occupe du reste !</p>

        {{ form_start(form) }}
        <div class="alert alert-light">
            <h2 class="h4">Commencez par nous dire quelles sont les dates qui vous intéressent !</h2>
            <div class="row">
                <div class="col">
                    {{form_row(form.startDate)}}
                </div>
                <div class="col">
                    {{form_row(form.endDate)}}
                </div>
            </div>
            <h4 id="price" class="mt-2">Montant du séjour : <strong><span id="amount">...</span> &euro;</strong></h4>
            <span id="days">0</span> nuit(s) à <span id="price2">{{ad.price | number_format(2, ',', ' ')}} € </span> par nuit

            <h4 class="mt-3">Vous avez un commentaire ?</h4>
            {{ form_row(form.comment) }}
        </div>


        <h2>Vous avez terminé !</h2>
        <p>Vacances de rêve ? Hébergement pour le boulot ? Peu importe, on est avec vous !</p>

        <button type="submit" class="btn btn-success animate-magic" data-animation="magic">Je réserve !</button>

        {{form_end(form)}}
    
    </div>
{% endblock %}

{% block javascripts %}

    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/js/bootstrap-datepicker.min.js"></script>

    <script>
        $(document).ready(function(){
            $('#booking_startDate, #booking_endDate').datepicker({
                format: 'dd/mm/yyyy',
                datesDisabled: [
                    {% for day in ad.notAvailableDays %}
                        "{{ day.format('d/m/Y') }}",
                    {% endfor %}
                ],
                startDate: new Date()
            });
            $('#booking_startDate, #booking_endDate').on('change', calculateAmount);
        });
        function calculateAmount() {
            // Je prend les dates
            // 22/11/2019
            // regex ??
            // 2019-11-22
            let endDate = new Date(
                $('#booking_endDate')
                    .val()
                    .replace(/(\d+)\/(\d+)\/(\d{4})/, '$3-$2-$1')
            );
            
            let startDate = new Date(
                $('#booking_startDate')
                    .val()
                    .replace(/(\d+)\/(\d+)\/(\d{4})/, '$3-$2-$1')
            );
            if(startDate && endDate && startDate < endDate){
                let DAY_TIME  = 24 * 60 * 60 * 1000;
                let interval  = endDate.getTime() - startDate.getTime();
                let days      = interval / DAY_TIME;
                let amount    = days * {{ ad.price }};
                $('#days').text(days);
                $('#amount').text(amount.toLocaleString('fr-FR'));
            }
        }
    
    </script>

{% endblock %}

symfony/templates/booking/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Réservation n°{{booking.id}}{% endblock %}

{% block body %}

    {% set ad = booking.ad %}
    {% set author = ad.author %}

    <div class="container">
        <h1 class="my-5">Votre réservation (n°{{booking.id}})</h1>

        {% if app.request.query.get('withAlert') %}
            <div class="alert alert-success">
                <h4 class="alert-heading">Bravo !</h4>
                <p>
                    Votre réservation auprès de
                    <strong>
                        <a href="{{ path("user_show", {'slug': author.slug})}}">{{author.fullName}}</a>
                    </strong>
                    pour l'annonce
                    <strong>
                        <a href="{{ path("ads_show", {'slug': ad.slug})}}">{{ad.title}}</a>
                    </strong>
                    a bien été prise en compte !
                </p>
            </div>
        {% endif %}

        <div class="row">
            <div class="col">
                <div class="alert alert-light">
                    <h2>Détails</h2>
                    <dl class="row">
                        <dt class="col-md-4">Numéro</dt>
                        <dd class="col-md-8">{{booking.id}}</dd>
                        <dt class="col-md-4">Date d'arrivée</dt>
                        <dd class="col-md-8">{{booking.startDate | date('d/m/Y')}}</dd>
                        <dt class="col-md-4">Date de départ</dt>
                        <dd class="col-md-8">{{booking.endDate | date('d/m/Y')}}</dd>
                        <dt class="col-md-4">Nombre de nuits</dt>
                        <dd class="col-md-8">{{booking.duration}}</dd>
                        <dt class="col-md-4">Montant total</dt>
                        <dd class="col-md-8">{{booking.amount | number_format(2, ',', ' ')}} &euro;</dd>
                        <dt class="col-md-4">Commentaire</dt>
                        <dd class="col-md-8">{{booking.comment | default('Aucun commentaire')}}</dd>
                    </dl>

                    <hr>

                    <h2 class="alert-heading">Votre hôte</h2>

                    <div class="row mb-3">
                        <div class="col-3">
                            <img src="{{author.picture}}" class="avatar avatar-medium" alt="Avatar de {{author.fullName}}">
                        </div>
                        <div class="col-9">
                            <h4>
                                <a href="{{ path('user_show', {'slug': author.slug}) }}">{{ author.fullName }}</a>
                            </h4>

                            <span class="badge badge-primary">{{author.ads|length}} annonces</span>
                        </div>
                    </div>
                    {{author.description | raw}}

                    <a href="{{ path("user_show", {'slug': author.slug}) }}" class="btn btn-primary">Plus d'infos sur {{author.firstName}}</a>
                </div>

                <div class="alert alert-light" id="comment">
                    <h2 class="alert-heading">Votre avis compte !</h2>
                    {% if date() > date(booking.endDate) %}
                        {% set comment = booking.ad.commentFromAuthor(app.user) %}
                        {% if comment is not null %}
                            <blockquote>
                                {{comment.content}}
                            </blockquote>

                            <strong>Note : </strong> {% include 'shared/rating.html.twig' with {'rating': comment.rating} %}
                        {% else %}
                            {{ form_start(form) }}
                            {{ form_widget(form) }}
                            <button type="submit" class="btn btn-success">Confirmer !</button>
                            {{ form_end(form) }}
                        {% endif %}

                    {% else %}
                        <p>Vous ne pourrez pas noter cette annonce tant que votre voyage ne sera pas complet !</p>
                    {% endif %}
                </div>
            </div>
            <div class="col">
                <div class="alert alert-light">
                    <h2 class="alert-heading">Votre hébergement</h2>

                    <h4>
                        <a href="{{ path('ads_show', {'slug': ad.slug}) }}">{{ad.title}}</a>
                    </h4>

                    <img src="{{ad.coverImage}}" alt="Image de {{ad.title}}" class="img-fluid">

                    {{ad.content | raw}}

                    <a href="{{path('ads_show', {'slug': ad.slug})}}" class="btn btn-primary">Plus d'informations</a>
                </div>
                <div id="mapid"></div>
            </div>
        </div>
    </div>
{% endblock %}
{% block javascripts %}
    <script>
        var mymap = L.map('mapid').setView([51.505, -0.09], 14);
        var marker = L.marker([51.505, -0.09]).addTo(mymap);
        L.tileLayer('https://api.mapbox.com/styles/v1/{id}/tiles/{z}/{x}/{y}?access_token={accessToken}', {
            attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
            maxZoom: 18,
            id: 'mapbox/streets-v11',
            accessToken: 'pk.eyJ1Ijoia2FsaWxpbnV4NjkiLCJhIjoiY2s0aWZkZW9xMWtmNzNmbWdmdzN0M2V1YSJ9.x_7zrgJ4DrIsopADQrq5Sg'
        }).addTo(mymap);
    </script>
{% endblock %}